download/panel/gitea/update.sh
2024-11-10 02:06:42 +08:00

75 lines
2.1 KiB (Stored with Git LFS)
Bash

#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
channel=${1}
version=${2}
gitea_path="${setup_path}/server/gitea"
# 架构判断
if [ ${ARCH} == "x86_64" ]; then
gitea_file="gitea-${version}-linux-amd64.7z"
elif [ ${ARCH} == "aarch64" ]; then
gitea_file="gitea-${version}-linux-arm64.7z"
else
error "不支持的架构"
fi
# 下载
cd ${gitea_path}
wget -T 120 -t 3 -O ${gitea_path}/${gitea_file} ${download_url}/gitea/${gitea_file}
wget -T 20 -t 3 -O ${gitea_path}/${gitea_file}.sha256 ${download_url}/gitea/${gitea_file}.sha256
if ! sha256sum --status -c ${gitea_path}/${gitea_file}.sha256; then
rm -rf ${gitea_path}
error "gitea 校验失败"
fi
# 解压
cd ${gitea_path}
7z x ${gitea_file}
rm -f ${gitea_file} ${gitea_file}.sha256
# 替换文件
systemctl stop gitea
rm -f gitea
mv gitea-${version}-linux-* gitea
if [ ! -f "${gitea_path}/gitea" ]; then
error "gitea 解压失败"
fi
chown -R www:www ${gitea_path}
chmod -R 700 ${gitea_path}
systemctl start gitea
if [ "$?" != "0" ]; then
error "启动失败"
fi
panel-cli app write gitea ${channel} ${version}
echo -e $HR
echo "升级完成"
echo -e $HR